"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cbor_1 = __importDefault(require("cbor"));
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
function decodeCBOR(obj) {
    return new Promise((res, rej) => {
        let decoder = new cbor_1.default.Decoder();
        let data;
        decoder.on('data', buf => {
            data = buf;
        });
        decoder.on('error', rej);
        decoder.on('finish', () => res(data));
        decoder.end(obj);
    });
}
// tslint:disable-next-line: no-floating-promises
(async () => {
    let files = process.argv.slice(2);
    let ix = 0;
    for (let f of files) {
        if (path_1.default.extname(f) !== '.cbor')
            continue;
        let d = await decodeCBOR(fs_1.default.readFileSync(f));
        let dir = path_1.default.dirname(f);
        fs_1.default.writeFileSync(path_1.default.join(dir, path_1.default.basename(f, '.cbor') + '.json'), JSON.stringify(d), 'utf8');
        console.log(`[${++ix}/${files.length}] Written ${path_1.default.join(dir, path_1.default.basename(f, '.cbor') + '.json')}`);
    }
})();
//# sourceMappingURL=cbor2json.js.map