"use strict";
/**
 * Edge Impulse API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrganizationPortalsApi = exports.OrganizationPortalsApiApiKeys = void 0;
// tslint:disable-next-line: variable-name, no-var-requires
const PATH = require('path');
// tslint:disable-next-line: no-unsafe-any
module.paths.push(PATH.join(process.cwd(), 'node_modules'));
const localVarRequest = require("request");
const models_1 = require("../model/models");
const models_2 = require("../model/models");
let defaultBasePath = 'https://studio.edgeimpulse.com/v1';
// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================
var OrganizationPortalsApiApiKeys;
(function (OrganizationPortalsApiApiKeys) {
    OrganizationPortalsApiApiKeys[OrganizationPortalsApiApiKeys["ApiKeyAuthentication"] = 0] = "ApiKeyAuthentication";
    OrganizationPortalsApiApiKeys[OrganizationPortalsApiApiKeys["JWTAuthentication"] = 1] = "JWTAuthentication";
    OrganizationPortalsApiApiKeys[OrganizationPortalsApiApiKeys["JWTHttpHeaderAuthentication"] = 2] = "JWTHttpHeaderAuthentication";
})(OrganizationPortalsApiApiKeys = exports.OrganizationPortalsApiApiKeys || (exports.OrganizationPortalsApiApiKeys = {}));
class OrganizationPortalsApi {
    constructor(basePathOrUsername, opts, password, basePath) {
        this._basePath = defaultBasePath;
        this.defaultHeaders = {};
        this._useQuerystring = false;
        this._opts = {};
        this.authentications = {
            'default': new models_1.VoidAuth(),
            'ApiKeyAuthentication': new models_2.ApiKeyAuth('header', 'x-api-key'),
            'JWTAuthentication': new models_2.ApiKeyAuth('cookie', 'jwt'),
            'JWTHttpHeaderAuthentication': new models_2.ApiKeyAuth('header', 'x-jwt-token'),
        };
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        }
        else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername;
            }
        }
        this.opts = opts !== null && opts !== void 0 ? opts : {};
    }
    set useQuerystring(value) {
        this._useQuerystring = value;
    }
    set basePath(basePath) {
        this._basePath = basePath;
    }
    get basePath() {
        return this._basePath;
    }
    set opts(opts) {
        this._opts = opts;
    }
    get opts() {
        return this._opts;
    }
    setDefaultAuthentication(auth) {
        this.authentications.default = auth;
    }
    setApiKey(key, value) {
        this.authentications[OrganizationPortalsApiApiKeys[key]].apiKey = value;
    }
    /**
     * Creates a new upload portal for the organization.
     * @summary Create upload portal
     * @param organizationId Organization ID
     * @param createOrganizationPortalRequest
     */
    async createOrganizationPortal(organizationId, createOrganizationPortalRequest, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/organizations/{organizationId}/portals/create'
            .replace('{' + 'organizationId' + '}', encodeURIComponent(String(organizationId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'organizationId' is not null or undefined
        if (organizationId === null || organizationId === undefined) {
            throw new Error('Required parameter organizationId was null or undefined when calling createOrganizationPortal.');
        }
        // verify required parameter 'createOrganizationPortalRequest' is not null or undefined
        if (createOrganizationPortalRequest === null || createOrganizationPortalRequest === undefined) {
            throw new Error('Required parameter createOrganizationPortalRequest was null or undefined when calling createOrganizationPortal.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
            body: models_1.ObjectSerializer.serialize(createOrganizationPortalRequest, "CreateOrganizationPortalRequest")
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "CreateOrganizationPortalResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Deletes an upload portal for the organization.
     * @summary Delete upload portal
     * @param organizationId Organization ID
     * @param portalId Portal ID
     */
    async deleteOrganizationPortal(organizationId, portalId, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/organizations/{organizationId}/portals/{portalId}/delete'
            .replace('{' + 'organizationId' + '}', encodeURIComponent(String(organizationId)))
            .replace('{' + 'portalId' + '}', encodeURIComponent(String(portalId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'organizationId' is not null or undefined
        if (organizationId === null || organizationId === undefined) {
            throw new Error('Required parameter organizationId was null or undefined when calling deleteOrganizationPortal.');
        }
        // verify required parameter 'portalId' is not null or undefined
        if (portalId === null || portalId === undefined) {
            throw new Error('Required parameter portalId was null or undefined when calling deleteOrganizationPortal.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'DELETE',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "GenericApiResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Retrieve a single upload portals identified by ID.
     * @summary Retrieve upload portal information
     * @param organizationId Organization ID
     * @param portalId Portal ID
     */
    async getOrganizationPortal(organizationId, portalId, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/organizations/{organizationId}/portals/{portalId}'
            .replace('{' + 'organizationId' + '}', encodeURIComponent(String(organizationId)))
            .replace('{' + 'portalId' + '}', encodeURIComponent(String(portalId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'organizationId' is not null or undefined
        if (organizationId === null || organizationId === undefined) {
            throw new Error('Required parameter organizationId was null or undefined when calling getOrganizationPortal.');
        }
        // verify required parameter 'portalId' is not null or undefined
        if (portalId === null || portalId === undefined) {
            throw new Error('Required parameter portalId was null or undefined when calling getOrganizationPortal.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "GetOrganizationPortalResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Retrieve all configured upload portals.
     * @summary List upload portals
     * @param organizationId Organization ID
     */
    async listOrganizationPortals(organizationId, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/organizations/{organizationId}/portals'
            .replace('{' + 'organizationId' + '}', encodeURIComponent(String(organizationId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'organizationId' is not null or undefined
        if (organizationId === null || organizationId === undefined) {
            throw new Error('Required parameter organizationId was null or undefined when calling listOrganizationPortals.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "ListOrganizationPortalsResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Rotates the token for an upload portal.
     * @summary Rotate upload portal token
     * @param organizationId Organization ID
     * @param portalId Portal ID
     */
    async rotateOrganizationPortalToken(organizationId, portalId, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/organizations/{organizationId}/portals/{portalId}/rotate-token'
            .replace('{' + 'organizationId' + '}', encodeURIComponent(String(organizationId)))
            .replace('{' + 'portalId' + '}', encodeURIComponent(String(portalId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'organizationId' is not null or undefined
        if (organizationId === null || organizationId === undefined) {
            throw new Error('Required parameter organizationId was null or undefined when calling rotateOrganizationPortalToken.');
        }
        // verify required parameter 'portalId' is not null or undefined
        if (portalId === null || portalId === undefined) {
            throw new Error('Required parameter portalId was null or undefined when calling rotateOrganizationPortalToken.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'DELETE',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "GenericApiResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Updates an upload portal for the organization.
     * @summary Update upload portal
     * @param organizationId Organization ID
     * @param portalId Portal ID
     * @param createOrganizationPortalRequest
     */
    async updateOrganizationPortal(organizationId, portalId, createOrganizationPortalRequest, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/organizations/{organizationId}/portals/{portalId}/update'
            .replace('{' + 'organizationId' + '}', encodeURIComponent(String(organizationId)))
            .replace('{' + 'portalId' + '}', encodeURIComponent(String(portalId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'organizationId' is not null or undefined
        if (organizationId === null || organizationId === undefined) {
            throw new Error('Required parameter organizationId was null or undefined when calling updateOrganizationPortal.');
        }
        // verify required parameter 'portalId' is not null or undefined
        if (portalId === null || portalId === undefined) {
            throw new Error('Required parameter portalId was null or undefined when calling updateOrganizationPortal.');
        }
        // verify required parameter 'createOrganizationPortalRequest' is not null or undefined
        if (createOrganizationPortalRequest === null || createOrganizationPortalRequest === undefined) {
            throw new Error('Required parameter createOrganizationPortalRequest was null or undefined when calling updateOrganizationPortal.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
            body: models_1.ObjectSerializer.serialize(createOrganizationPortalRequest, "CreateOrganizationPortalRequest")
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "UpdateOrganizationPortalResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Retrieve a subset of files from the portal, to be used in the data source wizard.
     * @summary Verify upload portal information
     * @param organizationId Organization ID
     * @param portalId Portal ID
     */
    async verifyOrganizationPortal(organizationId, portalId, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/organizations/{organizationId}/portals/{portalId}/verify'
            .replace('{' + 'organizationId' + '}', encodeURIComponent(String(organizationId)))
            .replace('{' + 'portalId' + '}', encodeURIComponent(String(portalId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'organizationId' is not null or undefined
        if (organizationId === null || organizationId === undefined) {
            throw new Error('Required parameter organizationId was null or undefined when calling verifyOrganizationPortal.');
        }
        // verify required parameter 'portalId' is not null or undefined
        if (portalId === null || portalId === undefined) {
            throw new Error('Required parameter portalId was null or undefined when calling verifyOrganizationPortal.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "VerifyOrganizationBucketResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
}
exports.OrganizationPortalsApi = OrganizationPortalsApi;
//# sourceMappingURL=organizationPortalsApi.js.map