"use strict";
/**
 * Edge Impulse API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequiresSudoApi = exports.RequiresSudoApiApiKeys = void 0;
// tslint:disable-next-line: variable-name, no-var-requires
const PATH = require('path');
// tslint:disable-next-line: no-unsafe-any
module.paths.push(PATH.join(process.cwd(), 'node_modules'));
const localVarRequest = require("request");
const models_1 = require("../model/models");
const models_2 = require("../model/models");
let defaultBasePath = 'https://studio.edgeimpulse.com/v1';
// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================
var RequiresSudoApiApiKeys;
(function (RequiresSudoApiApiKeys) {
    RequiresSudoApiApiKeys[RequiresSudoApiApiKeys["ApiKeyAuthentication"] = 0] = "ApiKeyAuthentication";
    RequiresSudoApiApiKeys[RequiresSudoApiApiKeys["JWTAuthentication"] = 1] = "JWTAuthentication";
    RequiresSudoApiApiKeys[RequiresSudoApiApiKeys["JWTHttpHeaderAuthentication"] = 2] = "JWTHttpHeaderAuthentication";
})(RequiresSudoApiApiKeys = exports.RequiresSudoApiApiKeys || (exports.RequiresSudoApiApiKeys = {}));
class RequiresSudoApi {
    constructor(basePathOrUsername, opts, password, basePath) {
        this._basePath = defaultBasePath;
        this.defaultHeaders = {};
        this._useQuerystring = false;
        this._opts = {};
        this.authentications = {
            'default': new models_1.VoidAuth(),
            'ApiKeyAuthentication': new models_2.ApiKeyAuth('header', 'x-api-key'),
            'JWTAuthentication': new models_2.ApiKeyAuth('cookie', 'jwt'),
            'JWTHttpHeaderAuthentication': new models_2.ApiKeyAuth('header', 'x-jwt-token'),
        };
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        }
        else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername;
            }
        }
        this.opts = opts !== null && opts !== void 0 ? opts : {};
    }
    set useQuerystring(value) {
        this._useQuerystring = value;
    }
    set basePath(basePath) {
        this._basePath = basePath;
    }
    get basePath() {
        return this._basePath;
    }
    set opts(opts) {
        this._opts = opts;
    }
    get opts() {
        return this._opts;
    }
    setDefaultAuthentication(auth) {
        this.authentications.default = auth;
    }
    setApiKey(key, value) {
        this.authentications[RequiresSudoApiApiKeys[key]].apiKey = value;
    }
    /**
     * Admin-only API to set the list of identity provider for a given domain.
     * @summary Add or update SSO settings for a domain
     * @param domainName Email domain name
     * @param adminAddOrUpdateSSODomainIdPsRequest
     */
    async adminAddOrUpdateSSODomainIdPs(domainName, adminAddOrUpdateSSODomainIdPsRequest, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/admin/sso/{domainName}'
            .replace('{' + 'domainName' + '}', encodeURIComponent(String(domainName)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'domainName' is not null or undefined
        if (domainName === null || domainName === undefined) {
            throw new Error('Required parameter domainName was null or undefined when calling adminAddOrUpdateSSODomainIdPs.');
        }
        // verify required parameter 'adminAddOrUpdateSSODomainIdPsRequest' is not null or undefined
        if (adminAddOrUpdateSSODomainIdPsRequest === null || adminAddOrUpdateSSODomainIdPsRequest === undefined) {
            throw new Error('Required parameter adminAddOrUpdateSSODomainIdPsRequest was null or undefined when calling adminAddOrUpdateSSODomainIdPs.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
            body: models_1.ObjectSerializer.serialize(adminAddOrUpdateSSODomainIdPsRequest, "AdminAddOrUpdateSSODomainIdPsRequest")
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "GenericApiResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Admin-only API to delete the list of identity providers for a given domain.
     * @summary Delete SSO settings for a domain
     * @param domainName Email domain name
     */
    async adminDeleteSSODomainIdPs(domainName, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/admin/sso/{domainName}'
            .replace('{' + 'domainName' + '}', encodeURIComponent(String(domainName)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'domainName' is not null or undefined
        if (domainName === null || domainName === undefined) {
            throw new Error('Required parameter domainName was null or undefined when calling adminDeleteSSODomainIdPs.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'DELETE',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "GenericApiResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Admin-only API to get the list of identity providers enabled for a given domain.
     * @summary Get SSO settings for a domain
     * @param domainName Email domain name
     */
    async adminGetSSODomainIdPs(domainName, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/admin/sso/{domainName}'
            .replace('{' + 'domainName' + '}', encodeURIComponent(String(domainName)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'domainName' is not null or undefined
        if (domainName === null || domainName === undefined) {
            throw new Error('Required parameter domainName was null or undefined when calling adminGetSSODomainIdPs.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "AdminGetSSODomainIdPsResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
    /**
     * Admin-only API to get the SSO settings.
     * @summary Get SSO settings
     */
    async adminGetSSOSettings(options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/admin/sso';
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "AdminGetSSOSettingsResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
}
exports.RequiresSudoApi = RequiresSudoApi;
//# sourceMappingURL=requiresSudoApi.js.map