"use strict";
/**
 * Edge Impulse API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequiresThirdPartyAuthApiKeyApi = exports.RequiresThirdPartyAuthApiKeyApiApiKeys = void 0;
// tslint:disable-next-line: variable-name, no-var-requires
const PATH = require('path');
// tslint:disable-next-line: no-unsafe-any
module.paths.push(PATH.join(process.cwd(), 'node_modules'));
const localVarRequest = require("request");
const models_1 = require("../model/models");
const models_2 = require("../model/models");
let defaultBasePath = 'https://studio.edgeimpulse.com/v1';
// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================
var RequiresThirdPartyAuthApiKeyApiApiKeys;
(function (RequiresThirdPartyAuthApiKeyApiApiKeys) {
    RequiresThirdPartyAuthApiKeyApiApiKeys[RequiresThirdPartyAuthApiKeyApiApiKeys["ApiKeyAuthentication"] = 0] = "ApiKeyAuthentication";
    RequiresThirdPartyAuthApiKeyApiApiKeys[RequiresThirdPartyAuthApiKeyApiApiKeys["JWTAuthentication"] = 1] = "JWTAuthentication";
    RequiresThirdPartyAuthApiKeyApiApiKeys[RequiresThirdPartyAuthApiKeyApiApiKeys["JWTHttpHeaderAuthentication"] = 2] = "JWTHttpHeaderAuthentication";
})(RequiresThirdPartyAuthApiKeyApiApiKeys = exports.RequiresThirdPartyAuthApiKeyApiApiKeys || (exports.RequiresThirdPartyAuthApiKeyApiApiKeys = {}));
class RequiresThirdPartyAuthApiKeyApi {
    constructor(basePathOrUsername, opts, password, basePath) {
        this._basePath = defaultBasePath;
        this.defaultHeaders = {};
        this._useQuerystring = false;
        this._opts = {};
        this.authentications = {
            'default': new models_1.VoidAuth(),
            'ApiKeyAuthentication': new models_2.ApiKeyAuth('header', 'x-api-key'),
            'JWTAuthentication': new models_2.ApiKeyAuth('cookie', 'jwt'),
            'JWTHttpHeaderAuthentication': new models_2.ApiKeyAuth('header', 'x-jwt-token'),
        };
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        }
        else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername;
            }
        }
        this.opts = opts !== null && opts !== void 0 ? opts : {};
    }
    set useQuerystring(value) {
        this._useQuerystring = value;
    }
    set basePath(basePath) {
        this._basePath = basePath;
    }
    get basePath() {
        return this._basePath;
    }
    set opts(opts) {
        this._opts = opts;
    }
    get opts() {
        return this._opts;
    }
    setDefaultAuthentication(auth) {
        this.authentications.default = auth;
    }
    setApiKey(key, value) {
        this.authentications[RequiresThirdPartyAuthApiKeyApiApiKeys[key]].apiKey = value;
    }
    /**
     * Login as a user as a third-party authentication provider. If the user does not exists, it\'s automatically created. You can only log in as users that were previously created by you.
     * @summary Create or login a user
     * @param authId Auth ID
     * @param createUserThirdPartyRequest
     */
    async createUserThirdParty(authId, createUserThirdPartyRequest, options = { headers: {} }) {
        const localVarPath = this.basePath + '/api/third-party-auth/{authId}/login'
            .replace('{' + 'authId' + '}', encodeURIComponent(String(authId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({
            'User-Agent': 'edgeimpulse-api nodejs'
        }, this.defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        }
        else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams = {};
        // verify required parameter 'authId' is not null or undefined
        if (authId === null || authId === undefined) {
            throw new Error('Required parameter authId was null or undefined when calling createUserThirdParty.');
        }
        // verify required parameter 'createUserThirdPartyRequest' is not null or undefined
        if (createUserThirdPartyRequest === null || createUserThirdPartyRequest === undefined) {
            throw new Error('Required parameter createUserThirdPartyRequest was null or undefined when calling createUserThirdParty.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        Object.assign(localVarHeaderParams, this.opts.extraHeaders);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            agentOptions: { keepAlive: false },
            json: true,
            body: models_1.ObjectSerializer.serialize(createUserThirdPartyRequest, "CreateUserThirdPartyRequest")
        };
        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.ApiKeyAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.JWTHttpHeaderAuthentication.applyToRequest(localVarRequestOptions));
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));
        return authenticationPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    localVarRequestOptions.formData = localVarFormParams;
                }
                else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    }
                    else {
                        body = models_1.ObjectSerializer.deserialize(body, "CreateUserThirdPartyResponse");
                        const errString = `Failed to call "${localVarPath}", returned ${response.statusCode}: ` + response.body;
                        if (typeof body.success === 'boolean' && !body.success) {
                            reject(new Error(body.error || errString));
                        }
                        else if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve(body);
                        }
                        else {
                            reject(errString);
                        }
                    }
                });
            });
        });
    }
}
exports.RequiresThirdPartyAuthApiKeyApi = RequiresThirdPartyAuthApiKeyApi;
//# sourceMappingURL=requiresThirdPartyAuthApiKeyApi.js.map