"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseUploaderInfo = exports.validateBoundingBoxLabels = exports.parseBoundingBoxLabels = void 0;
function parseBoundingBoxLabels(jsonFile) {
    const data = JSON.parse(jsonFile);
    return validateBoundingBoxLabels(data);
}
exports.parseBoundingBoxLabels = parseBoundingBoxLabels;
function validateBoundingBoxLabels(data) {
    if (data.version !== 1) {
        throw new Error('Invalid version');
    }
    if (data.type !== 'bounding-box-labels') {
        throw new Error('Invalid type');
    }
    if (typeof data.boundingBoxes !== 'object') {
        throw new Error('boundingBoxes is not an object');
    }
    return data;
}
exports.validateBoundingBoxLabels = validateBoundingBoxLabels;
function parseUploaderInfo(jsonFile) {
    let data = JSON.parse(jsonFile);
    if (data.version !== 1) {
        throw new Error('Invalid version');
    }
    if (!Array.isArray(data.files)) {
        throw new Error('files is not an array');
    }
    return data;
}
exports.parseUploaderInfo = parseUploaderInfo;
//# sourceMappingURL=bounding-box-file-types.js.map