"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeExtension = exports.findCategoryMatch = void 0;
/**
 * Try to find a category from a file name or path
 * @param name Name to examine
 * @returns Category if one can be found
 */
function findCategoryMatch(name) {
    name = name.toLowerCase();
    if (name.includes('val') || name.includes('test')) {
        return 'testing';
    }
    else if (name.includes('train')) {
        return 'training';
    }
    return undefined;
}
exports.findCategoryMatch = findCategoryMatch;
/**
 * Remove the extension from a file
 * @param filename File name
 * @returns File name without extension
 */
function removeExtension(filename) {
    if (!filename.includes('.'))
        return filename;
    return filename.split('.').slice(0, -1).join('.');
}
exports.removeExtension = removeExtension;
//# sourceMappingURL=label-files-shared.js.map